/*
	------------------------------------------------------
	|Copyright (C) 1997 Michele PERNIOLA - TRANI (BA)    |
	|Programmatore: Michele Perniola			              |
	|Procedura	  : victest - TVicPort.dll test program  |
	|Rel. 1.00	  : 20/12/95		                       |
	|Programma	  : victest.c              				  |
	|Rev. 1.00    : 05/07/97                             |
	|Descrizione  : Complete test program                |
	------------------------------------------------------
*/

//----------------------------------------------------------------------------
// INCLUDE FILES
//----------------------------------------------------------------------------

#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "TVicPort.h"

// functions declaration


LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK	 MainDialogProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK    AboutDialogProc(HWND, UINT, WPARAM, LPARAM);

//int WINAPI WinMain (HANDLE hInstance);//, HANDLE hPrevInstance,
								//							  LPSTR lpszCmdLine, int nCmdShow);
//int  WINAPI    WinMain(HINSTANCE , HINSTANCE , LPSTR, int);
//LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
//LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
//BOOL CALLBACK	 MainDialogProc(HWND, UINT, WPARAM, LPARAM);
//BOOL CALLBACK    AboutDialogProc(HWND, UINT, WPARAM, LPARAM);

void ShowButtons(HWND hDlg);

HANDLE hInst;
HWND   hDlgMain = NULL;
DLGPROC lpAbtProc;

char AppName[] = "TVicPort.DLL Test";      // Name of application


//----------------------------------------------------------------------------
DWORD
HexToInt(char* s)
{
	char hexch[] = "0123456789ABCDEF";
	int i,j;
   DWORD r,n,k;
   char ch;

  	k=1; r=0;
  	for (i=strlen(s);  i>0; i--) {
   	ch = s[i-1]; if (ch > 0x3f) ch &= 0xDF;
   	n = 0;
    	for (j = 0; j<16; j++)
      	if (ch == hexch[j])
         	n = j;
    	r += (n*k);
     	k *= 16;
	}
  	return r;
}


//----------------------------------------------------------------------------
char*
PrintMemLine(char *szBuf, LPSTR mem, int len, int dwid, DWORD olbl)
{
	int i, j;
	BYTE  c;
   BYTE  buff[80];
   BYTE  tbuf[80];

	if (len > dwid)
   	len = dwid;

	*szBuf = 0;

	// memory address
   sprintf((char *)tbuf, "%08X ", olbl);
   strcpy(szBuf, (char *)tbuf);

   for (i = 0; i < len; i++) {
   	c = *mem++;

       sprintf((char *)tbuf, "%02X", c);
       strcat(szBuf, (char *)tbuf);

       if (c >= 32 && c < 127)
       	buff[i] = c;
       else
       	buff[i] = 46;
    }

    j = dwid - i;

    buff[i] = 0;

    for (i = j; i > 0; i--)
        strcat(szBuf, "   ");

    // add ASCII codes.
    sprintf((char *)tbuf, " %s", (char *)buff);		// " |%s|"
    strcat(szBuf, (char *)tbuf);

    for (i = j; i > 0; i--)
        strcat(szBuf, " ");

    return(szBuf);
}


//----------------------------------------------------------------------------
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
   MSG	  msg;
   HWND   hWnd;
   WNDCLASS wc;
   FARPROC lpfn;
   hInst = hInstance;

	wc.style = 0;
   wc.lpfnWndProc  = MainWndProc;
   wc.cbClsExtra   = 0;
   wc.cbWndExtra   = 0;
   wc.hInstance    = hInstance;
   wc.hIcon	   	 = LoadIcon (hInstance, MAKEINTRESOURCE(IDI_APPICON));
   wc.hCursor	    = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground= (HBRUSH)COLOR_BACKGROUND;
   wc.lpszMenuName = NULL;
   wc.lpszClassName= "VictestWClass";

   if (!RegisterClass(&wc))
		return FALSE;

   hWnd = CreateWindow(
		  "VictestWClass",
		  AppName,
		  WS_OVERLAPPEDWINDOW|WS_CAPTION|WS_MINIMIZEBOX|WS_SYSMENU,
		  CW_USEDEFAULT,
		  CW_USEDEFAULT,//0,
		  CW_USEDEFAULT,//0,
		  CW_USEDEFAULT,//0,
        NULL,
        NULL,
        hInstance,
		  NULL);

   lpfn = MakeProcInstance(MainDialogProc, hInst);

   hDlgMain = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAINDIALOG), hWnd, lpfn);

   ShowWindow(hWnd, nCmdShow);
   ShowWindow(hDlgMain, SW_SHOW);

   while(GetMessage (&msg, NULL, 0, 0)) {

      if(hDlgMain == NULL || !IsDialogMessage(hDlgMain,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
      }
   }
   return (msg.wParam);
}

//----------------------------------------------------------------------------
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   switch (msg) {

      case WM_CREATE:
	 		break;

      case WM_COMMAND:
		   return (DefWindowProc(hWnd, msg, wParam, lParam));

      case WM_SETFOCUS:
         SetFocus(hDlgMain);
	 		break;

      case WM_DESTROY:
	 		PostQuitMessage(0);
	 		break;

     default:
			return (DefWindowProc(hWnd, msg, wParam, lParam));

   }
   return (0);
}


//----------------------------------------------------------------------------
BOOL CALLBACK MainDialogProc(HWND hDlg, UINT message,
													WPARAM wParam, LPARAM lParam)
{

   RECT rect;
   char buffer[256];
   int i;
   WORD a;
	BYTE d;

   switch (message) {

      case WM_INITDIALOG:

         GetWindowRect(hDlg, &rect);
         // center and resize window
         SetWindowPos(  GetParent(hDlg),
                     	NULL,
                     	(GetSystemMetrics(SM_CXSCREEN)-(rect.right-rect.left)) >> 1, // left
                     	(GetSystemMetrics(SM_CYSCREEN)-(rect.bottom-rect.top + GetSystemMetrics(SM_CYCAPTION))) >>1, // top
                     	rect.right-rect.left, 	// width
                     	rect.bottom-rect.top + GetSystemMetrics(SM_CYCAPTION), // height
                     	SWP_NOZORDER);

   		if ((GetVersion() & 0x80000000) != 0)
	   		SetDlgItemText(hDlg, IDE_SOTYPE, "95");
			else
				SetDlgItemText(hDlg, IDE_SOTYPE, "NT");

   		SendDlgItemMessage(hDlg, IDE_ADDR01, EM_LIMITTEXT, 4, 0L);
   		SendDlgItemMessage(hDlg, IDE_ADDR02, EM_LIMITTEXT, 4, 0L);
   		SendDlgItemMessage(hDlg, IDE_ADDR03, EM_LIMITTEXT, 4, 0L);
		SendDlgItemMessage(hDlg, IDE_ADDR04, EM_LIMITTEXT, 4, 0L);

   		SendDlgItemMessage(hDlg, IDE_DATA01, EM_LIMITTEXT, 2, 0L);
   		SendDlgItemMessage(hDlg, IDE_DATA02, EM_LIMITTEXT, 2, 0L);
   		SendDlgItemMessage(hDlg, IDE_DATA03, EM_LIMITTEXT, 2, 0L);
   		SendDlgItemMessage(hDlg, IDE_DATA04, EM_LIMITTEXT, 2, 0L);

   		// set defalut data
   		SetDlgItemInt(hDlg, IDE_ADDR01, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_ADDR02, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_ADDR03, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_ADDR04, 0, FALSE);

   		SetDlgItemInt(hDlg, IDE_DATA01, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_DATA02, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_DATA03, 0, FALSE);
   		SetDlgItemInt(hDlg, IDE_DATA04, 0, FALSE);


//	   		hFontMemdump = CreateFont(-12, 0, 0, 0, FW_NORMAL,
//   			0, 0, 0,  ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
//            DEFAULT_QUALITY, FIXED_PITCH | FF_DONTCARE, "Courier New");

			ShowButtons(hDlg);

	 		return(TRUE);

      case WM_CLOSE:
			DestroyWindow(hDlg);
			hDlgMain = NULL;
			break;


      case WM_COMMAND:
			switch (wParam) {
			   case IDB_DRIVER:
					if (IsDriverOpened()) {
						CloseTVicPort();

					} else {
				   	if ( OpenTVicPort() ) {
   						SetHardAccess( (bool)((SendDlgItemMessage(hDlg, IDC_HARD, BM_GETSTATE, 0, 0) & 1) != 0) );
			  			}  else {
				         MessageBox(hDlg, "Driver VICPRTxx not found !", "Error",
                                MB_APPLMODAL | MB_OK | MB_ICONERROR);
						}
			   	}
   				ShowButtons(hDlg);
			      break;

				case IDB_READ:
            	for (i=0; i<4; i++) {
						GetDlgItemText(hDlg, IDE_ADDR01 + i, buffer, 40);
                  a = (WORD) HexToInt(buffer);
					   sprintf(buffer, "%02X", ReadPort( a ));
					   SetDlgItemText(hDlg, IDE_DATA01 + i, buffer);
					}
               break;

				case IDB_WRITE:
            	for (i=0; i<4; i++) {
						GetDlgItemText(hDlg, IDE_ADDR01 + i, buffer, 40);
					   a = (WORD) HexToInt(buffer);
						GetDlgItemText(hDlg, IDE_DATA01 + i, buffer, 40);
   					d = (BYTE) HexToInt(buffer);
                  WritePort(a, d);
					}
               break;

            case IDC_HARD:
					SetHardAccess( (bool)((SendDlgItemMessage(hDlg, IDC_HARD, BM_GETSTATE, 0, 0) & 1) != 0) );
               break;

		
			   case IDM_EXIT:
              	PostMessage(GetParent(hDlg),WM_CLOSE, (WPARAM)0, (LPARAM)0);
	      		break;

	   		default:
	      		return (FALSE);
			}
			break;

		case WM_DESTROY:

			if (IsDriverOpened()) {
				CloseTVicPort();
		   }

//			if (hFontMemdump)
//   			DeleteObject(hFontMemdump);

	 		return TRUE;

   }
	return (FALSE);
}


//----------------------------------------------------------------------------
void ShowButtons(HWND hDlg)
{
   //azzera la checkbox dell'accesso diretto
   SendDlgItemMessage(hDlg, IDC_HARD, BM_SETCHECK, (BOOL)TestHardAccess(), 0L);

	if (IsDriverOpened()) {
	   SendDlgItemMessage(hDlg, IDB_DRIVER, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"&Close Driver");
   } else {
   	SendDlgItemMessage(hDlg, IDB_DRIVER, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"&Open Driver");
	}

   EnableWindow(GetDlgItem(hDlg, IDB_READ)	, (BOOL) IsDriverOpened());
   EnableWindow(GetDlgItem(hDlg, IDB_WRITE)	, (BOOL) IsDriverOpened());
	
}


//----------------------------------------------------------------------------
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)													
{

	switch (message) {
		case WM_INITDIALOG:
      	return TRUE;

		case WM_SYSCOMMAND:
      	SendMessage(hDlgMain, message, wParam, lParam);
      	break;

		case WM_COMMAND:
      	EndDialog(hDlg, TRUE);
      	break;

  		default:
      	return FALSE;
	}

    return(TRUE);
}



//--------- END OF FILE  -----------------------------------------------------

